// DEMO8_10.CPP - Page scrolling demo
// make certain to include the T3DLIB1.CPP source file!

// INCLUDES ///////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN  

// you must #define INITGUID if not done elsewhere
#define INITGUID

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>

#include <ddraw.h>     // directX includes
#include <dinput.h>
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include "T3DLIB1.H"   // include the library header

#include "T3DLIB1.CPP"
#include "T3DLIB3.H" // sound stuff
#include "T3DLIB3.CPP"

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"

// default screen size
#define SCREEN_WIDTH    640  // size of screen
#define SCREEN_HEIGHT   480
#define SCREEN_BPP      8    // bits per pixel

#define BITMAP_ID            0x4D42 // universal id for a bitmap
#define MAX_COLORS_PALETTE   256

// skelaton directions
#define SKELATON_EAST         0
#define SKELATON_NEAST        1  
#define SKELATON_NORTH        2
#define SKELATON_NWEST        3
#define SKELATON_WEST         4
#define SKELATON_SWEST        5
#define SKELATON_SOUTH        6
#define SKELATON_SEAST        7

// bounding box for skull
#define MIN_X_FLY       200 
#define MAX_X_FLY       400
#define MIN_Y_FLY       300
#define MAX_Y_FLY       425

#define START_GLOW_COLOR  152 // starting color index to glow
#define END_GLOW_COLOR    159 // ending color index to glow
#define FLOOR_COLOR       116

// PROTOTYPES /////////////////////////////////////////////

// game console
int Game_Init(void *parms=NULL, int num_parms = 0);
int Game_Shutdown(void *parms=NULL, int num_parms = 0);
int Game_Main(void *parms=NULL,  int num_parms = 0);

// GLOBALS ////////////////////////////////////////////////

int health;

// windows vars
HWND      main_window_handle = NULL; // globally track main window
int       window_closed      = 0;    // tracks if window is closed
HINSTANCE main_instance      = NULL; // globally track hinstance

char buffer[80];                // used to print text

// demo globals
BOB skelaton;     // the player skelaton
BOB princess;	//the princess
BOB knight;
BOB peasant;
BOB skull;
BOB warrior;
BOB monk;
BOB wizard;

bool targetdestroyed;

int skullhealth;

// animation sequences for bob
int skelaton_anims[8][4] = { {0,1,0,2},
                             {0+4,1+4,0+4,2+4},
                             {0+8,1+8,0+8,2+8},
                             {0+12,1+12,0+12,2+12},
                             {0+16,1+16,0+16,2+16},
                             {0+20,1+20,0+20,2+20},
                             {0+24,1+24,0+24,2+24},
                             {0+28,1+28,0+28,2+28}, };
							 
int princess_anims[1][4] = { {0,1,0,2},};
int knight_anims[1][4] = { {0,1,0,2},};
int peasant_anims[1][4] = { {0,1,0,2},};
int skull_anims[1][4] = { {0,1,0,2},};
int warrior_anims[1][4] = { {0,1,0,2},};
int monk_anims[1][4] = { {0,1,0,2},};
int wizard_anims[1][4] = { {0,1,0,2},};



//sound id for directsound
int levelmusic;

int swordsound;

tagPALETTEENTRY palette2[256];

BITMAP_IMAGE landscape[3];      // the background    landscape 3 pages 3x1
int curr_page = 0;              // current page of landscape

//dinput
LPDIRECTINPUT8        lpdi      = NULL;    // dinput object
LPDIRECTINPUTDEVICE8  lpdikey   = NULL;    // dinput keyboard
// these contain the target records for all di input packets
UCHAR        keyboard_state[256]; // contains keyboard state table

// PROTOTYPES //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT		ps;		// used in WM_PAINT
HDC				hdc;	// handle to a device context
char buffer[80];        // used to print strings

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
        // return success
		return(0);
		} break;
   
	case WM_PAINT: 
		{
		// simply validate the window 
   	    hdc = BeginPaint(hwnd,&ps);	 
        
        // end painting
        EndPaint(hwnd,&ps);

        // return success
		return(0);
   		} break;

	case WM_DESTROY: 
		{

		// kill the application, this sends a WM_QUIT message 
		PostQuitMessage(0);

        // return success
		return(0);
		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

int Copy_Screen(UCHAR *source_bitmap,UCHAR *dest_buffer, int lpitch, int transparent)
{
// this function draws the bitmap onto the destination memory surface
// if transparent is 1 then color 0 will be transparent
// note this function does NOT clip, so be carefull!!!

UCHAR *dest_addr,   // starting address of bitmap in destination
      *source_addr; // starting adddress of bitmap data in source

UCHAR pixel;        // used to hold pixel value

int index,          // looping vars
    pixel_x;

// test if this bitmap is loaded

   // compute starting destination address
   dest_addr = dest_buffer;

   // compute the starting source address
   source_addr = source_bitmap;

   // is this bitmap transparent
   if (transparent)
   {
   // copy each line of bitmap into destination with transparency
   for (index=0; index < SCREEN_HEIGHT; index++)
       {
       // copy the memory
       for (pixel_x=0; pixel_x < SCREEN_WIDTH; pixel_x++)
           {
           if ((pixel = source_addr[pixel_x])!=0)
               dest_addr[pixel_x] = pixel;

           } // end if

       // advance all the pointers
       dest_addr   += lpitch;
       source_addr += SCREEN_WIDTH;

       } // end for index
   } // end if
   else
   {
   // non-transparent version
   // copy each line of bitmap into destination

   for (index=0; index < SCREEN_HEIGHT; index++)
       {
       // copy the memory
       memcpy(dest_addr, source_addr, SCREEN_WIDTH);

       // advance all the pointers
       dest_addr   += lpitch;
       source_addr += SCREEN_WIDTH;

       } // end for index

   } // end else

   // return success
   return(1);

} // end Copy_Screen

/////////////////////////////////////////////////////////////////////


void Do_Intro(void)
{
// the worlds simples intro

// clear out buffers
DDraw_Fill_Surface(lpddsback, 0);
DDraw_Fill_Surface(lpddsprimary, 0);

// draw in logo screen
Load_Bitmap_File(&bitmap8bit, "SCENE1.BMP");

// set the palette to background image palette
Set_Palette(bitmap8bit.palette);

// copy the bitmap to primary buffer
DDraw_Lock_Primary_Surface();
Copy_Screen(bitmap8bit.buffer,primary_buffer, primary_lpitch, 0);
DDraw_Unlock_Primary_Surface();

// unload bitmap file
Unload_Bitmap_File(&bitmap8bit);

Sleep(12000);

// transition to black
Screen_Transitions(SCREEN_DARKNESS,NULL,0);

// clear out buffers
DDraw_Fill_Surface(lpddsback, 0);
DDraw_Fill_Surface(lpddsprimary, 0);


} // end Do_Intro






// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
HDC        hdc;      // graphics device context

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

// save hinstance in global
main_instance = hinstance;

// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    "DirectDraw 8-Bit Page Scrolling Demo", // title
						    WS_POPUP | WS_VISIBLE,
					 	    0,0,	  // initial x,y
						    SCREEN_WIDTH,SCREEN_HEIGHT,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

// save main window handle
main_window_handle = hwnd;

// initialize game here
Game_Init();

// enter main event loop
while(TRUE)
	{
    // test if there is a message in queue, if so get it
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 
	   // test if this is a quit
       if (msg.message == WM_QUIT)
           break;
	
	   // translate any accelerator keys
	   TranslateMessage(&msg);

	   // send the message to the window proc
	   DispatchMessage(&msg);
	   } // end if
    
       // main game processing goes here
       Game_Main();
       
	} // end while

// closedown game here
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain

// GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms,  int num_parms)
{
// this function is where you do all the initialization 
// for your game

int index;         // looping var
char filename[80]; // used to build up files names

//health
health=100;

// initialize directdraw
DDraw_Init(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP);

//directsound stuff
//initialize dsound
if (!DSound_Init()) {
	//error
}

//load level 1 sound
levelmusic = DSound_Load_WAV("LEVEL1.WAV");
if (levelmusic == -1) { /*error*/}

swordsound = DSound_Load_WAV("SWORD.WAV");
if (swordsound = -1) { /*error*/}

//play the sound
int dummy = DSound_Play(levelmusic, DSBPLAY_LOOPING);

if (DirectInput8Create(main_instance,DIRECTINPUT_VERSION,
    IID_IDirectInput8, (void **)&lpdi,NULL)!=DI_OK) return(0);
// create a keyboard device  //////////////////////////////////
if (lpdi->CreateDevice(GUID_SysKeyboard, &lpdikey, NULL)!=DI_OK) return(0);
// set cooperation level
if (lpdikey->SetCooperativeLevel(main_window_handle, 
    DISCL_NONEXCLUSIVE | DISCL_BACKGROUND)!=DI_OK) return(0);
// set data format
if (lpdikey->SetDataFormat(&c_dfDIKeyboard)!=DI_OK)
   return(0);
// acquire the keyboard
if (lpdikey->Acquire()!=DI_OK)
   return(0);

// set up targetdestroyed
targetdestroyed=false;

// load in each page of the scrolling background
for (index = 0; index<3; index++)
    {
    // build up file name
    sprintf(filename,"LANDSCAPE%d.BMP",index+1);

    // load the background
    Load_Bitmap_File(&bitmap8bit, filename);

    // create and load the reactor bitmap image
    Create_Bitmap(&landscape[index], 0,0, 640, 480);
    Load_Image_Bitmap(&landscape[index],&bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
    Unload_Bitmap_File(&bitmap8bit);

    } // end for index

Do_Intro();

// set the palette to background image palette
Set_Palette(bitmap8bit.palette);

// now let's load in all the frames for the skelaton!!!

// create skelaton bob
if (!Create_BOB(&skelaton,0,0,72,74,32, // 56x72
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
   return(0);

if (!Create_BOB(&princess,0,0,72,74,32, // 56x72
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
   return(0);

if (!Create_BOB(&knight,0,0,72,74,32, // 56x72
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
   return(0);

if (!Create_BOB(&peasant,0,0,72,74,32, // 56x72
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
   return(0);

if (!Create_BOB(&skull,0,0,72,74,32, // 56x72
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
   return(0);

if (!Create_BOB(&monk,0,0,72,74,32, //56x72
			BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
	return 0;

if (!Create_BOB(&wizard,0,0,72,74,32, //56x72
			BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
	return 0;

if (!Create_BOB(&warrior,0,0,72,74,32, //56x72
			BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
	return 0;


// CREATE ENEMY BOB HERE

sprintf(filename,"PRINCESS.BMP");
Load_Bitmap_File(&bitmap8bit,filename);
Load_Frame_BOB(&princess,&bitmap8bit,0+0*1,0,0,BITMAP_EXTRACT_MODE_CELL); 
Unload_Bitmap_File(&bitmap8bit);
Load_Animation_BOB(&princess,0,1,princess_anims[0]);

sprintf(filename,"KNIGHT.BMP");
Load_Bitmap_File(&bitmap8bit,filename);
Load_Frame_BOB(&knight,&bitmap8bit,0+0*1,0,0,BITMAP_EXTRACT_MODE_CELL); 
Unload_Bitmap_File(&bitmap8bit);
Load_Animation_BOB(&knight,0,1,knight_anims[0]);

sprintf(filename,"PEASANT.BMP");
Load_Bitmap_File(&bitmap8bit,filename);
Load_Frame_BOB(&peasant,&bitmap8bit,0+0*1,0,0,BITMAP_EXTRACT_MODE_CELL); 
Unload_Bitmap_File(&bitmap8bit);
Load_Animation_BOB(&peasant,0,1,peasant_anims[0]);

sprintf(filename,"SKULL.BMP");
Load_Bitmap_File(&bitmap8bit,filename);
Load_Frame_BOB(&skull,&bitmap8bit,0+0*1,0,0,BITMAP_EXTRACT_MODE_CELL); 
Unload_Bitmap_File(&bitmap8bit);
Load_Animation_BOB(&skull,0,1,skull_anims[0]);

sprintf(filename,"WIZARD.BMP");
Load_Bitmap_File(&bitmap8bit,filename);
Load_Frame_BOB(&wizard,&bitmap8bit,0+0*1,0,0,BITMAP_EXTRACT_MODE_CELL); 
Unload_Bitmap_File(&bitmap8bit);
Load_Animation_BOB(&wizard,0,1,wizard_anims[0]);

sprintf(filename,"MONK.BMP");
Load_Bitmap_File(&bitmap8bit,filename);
Load_Frame_BOB(&monk,&bitmap8bit,0+0*1,0,0,BITMAP_EXTRACT_MODE_CELL); 
Unload_Bitmap_File(&bitmap8bit);
Load_Animation_BOB(&monk,0,1,monk_anims[0]);

sprintf(filename,"WARRIOR.BMP");
Load_Bitmap_File(&bitmap8bit,filename);
Load_Frame_BOB(&warrior,&bitmap8bit,0+0*1,0,0,BITMAP_EXTRACT_MODE_CELL); 
Unload_Bitmap_File(&bitmap8bit);
Load_Animation_BOB(&warrior,0,1,warrior_anims[0]);

// load the frames in 8 directions, 4 frames each
// each set of frames has a walk and a fire, frame sets
// are loaded in counter clockwise order looking down
// from a birds eys view or the x-z plane
for (int direction = 0; direction < 8; direction++)
    { 
    // build up file name
    sprintf(filename,"QUENSP%d.BMP",direction); // skelsp

    // load in new bitmap file
    Load_Bitmap_File(&bitmap8bit,filename);
 
    Load_Frame_BOB(&skelaton,&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&skelaton,&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&skelaton,&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&skelaton,&bitmap8bit,3+direction*4,0,1,BITMAP_EXTRACT_MODE_CELL);  

    // unload the bitmap file
    Unload_Bitmap_File(&bitmap8bit);

    // set the animation sequences for skelaton
    Load_Animation_BOB(&skelaton,direction,4,skelaton_anims[direction]);

    } // end for direction

// set up stating state of skelaton
Set_Animation_BOB(&skelaton, 0);
Set_Anim_Speed_BOB(&skelaton, 4);
Set_Vel_BOB(&skelaton, 0,0);
Set_Pos_BOB(&skelaton, 16, 410); // right above the floor

Set_Animation_BOB(&princess, 0);
Set_Anim_Speed_BOB(&princess,0);
Set_Vel_BOB(&princess,0,0);
Set_Pos_BOB(&princess,200,410);

Set_Animation_BOB(&knight, 0);
Set_Anim_Speed_BOB(&knight,0);
Set_Vel_BOB(&knight,0,0);
Set_Pos_BOB(&knight,570,410);

Set_Animation_BOB(&peasant, 0);
Set_Anim_Speed_BOB(&peasant,0);
Set_Vel_BOB(&peasant,0,0);
Set_Pos_BOB(&peasant,400,410);


// set clipping rectangle to screen extents so mouse cursor
// doens't mess up at edges
RECT screen_rect = {0,0,screen_width,screen_height};
lpddclipper = DDraw_Attach_Clipper(lpddsback,1,&screen_rect);

// hide the mouse
ShowCursor(FALSE);

// return success
return(1);

} // end Game_Init

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms,  int num_parms)
{
// this function is where you shutdown your game and
// release all resources that you allocated

// kill the landscape
for (int index=0; index<3; index++)
    Destroy_Bitmap(&landscape[index]);

// kill skelaton
Destroy_BOB(&skelaton);

//kill enemy
Destroy_BOB(&princess);
Destroy_BOB(&knight);
Destroy_BOB(&peasant);
Destroy_BOB(&skull);
Destroy_BOB(&warrior);
Destroy_BOB(&wizard);
Destroy_BOB(&monk);

// release keyboard
lpdikey->Unacquire();
lpdikey->Release();
lpdi->Release();

//shutdown dsound
if(!DSound_Shutdown()) { /*error*/ }
DSound_Stop_All_Sounds();

// shutdonw directdraw
DDraw_Shutdown();

// return success
return(1);
} // end Game_Shutdown


void enemy_AI(void)
{
// this function performs the enemy ai
// do tracking algorithm

if (skelaton.x > princess.x)
   princess.x+=1;
else
if (skelaton.x < princess.x)
   princess.x-=1;

if (skelaton.x > knight.x)
   knight.x+=1;
else
if (skelaton.x < knight.x)
   knight.x-=1;

if (skelaton.x > peasant.x)
   peasant.x+=1;
else
if (skelaton.x < peasant.x)
   peasant.x-=1;
else
if (skelaton.x < wizard.x)
   wizard.x-=1;
else
if (skelaton.x > wizard.x)
   wizard.x+=1;
else
if (skelaton.x < warrior.x)
   warrior.x-=1;
else
if (skelaton.x > warrior.x)
   warrior.x+=1;
else
if (skelaton.x < monk.x)
   monk.x-=1;
else
if (skelaton.x > monk.x)
   monk.x+=1;


// check boundaries
if (princess.x >= SCREEN_WIDTH)
   princess.x = -princess.width;
else
if (princess.x < -princess.width)
   princess.x = SCREEN_WIDTH;

if (knight.x >= SCREEN_WIDTH)
   knight.x = -knight.width;
else
if (knight.x < -knight.width)
   knight.x = SCREEN_WIDTH;

if (peasant.x >= SCREEN_WIDTH)
   peasant.x = -peasant.width;
else
if (peasant.x < -peasant.width)
   peasant.x = SCREEN_WIDTH;

if (wizard.x >= SCREEN_WIDTH)
   wizard.x=-wizard.width;
else
if (wizard.x < -wizard.width)
   wizard.x=SCREEN_WIDTH;

if (monk.x >= SCREEN_WIDTH)
   monk.x=-monk.width;
else
if (monk.x < -monk.width)
   monk.x=SCREEN_WIDTH;

if (warrior.x >= SCREEN_WIDTH)
   warrior.x=-warrior.width;
else
if (warrior.x < -warrior.width)
   warrior.x=SCREEN_WIDTH;


if (--skull.varsI[0] <= 0)
        {
        skull.xv = -4 + rand()%9;
        skull.yv = -4 + rand()%9;
        // set time for motion to occur
        skull.varsI[0] = 2+rand()%8;
        } // end if

    Move_BOB(&skull);
    Animate_BOB(&skull);

    // test if fly has left the fresh meat
    if (skull.x > MAX_X_FLY) 
       {
       skull.xv=-skull.xv;
       skull.x = MAX_X_FLY;
       } // end if

    if (skull.x < MIN_X_FLY) 
       {
       skull.xv=-skull.xv;
       skull.x = MIN_X_FLY;
       } // end if

    if (skull.y > MAX_Y_FLY) 
       {
       skull.yv=-skull.yv;
       skull.y = MAX_Y_FLY;
       } // end if

    if (skull.y < MIN_Y_FLY) 
       {
       skull.yv=-skull.yv;
       skull.y = MIN_Y_FLY;
       } // end if

} 

void GameOver() {
	// clear out buffers
DDraw_Fill_Surface(lpddsback, 0);
DDraw_Fill_Surface(lpddsprimary, 0);

// draw in logo screen
Load_Bitmap_File(&bitmap8bit, "GAMEOVER.BMP");

// set the palette to background image palette
Set_Palette(bitmap8bit.palette);

//DaDraw_Unlock_Primary_Surface(); // unlock if it is locked so you can move on

// copy the bitmap to primary buffer
DDraw_Lock_Primary_Surface();
Copy_Screen(bitmap8bit.buffer,primary_buffer, primary_lpitch, 0);
DDraw_Unlock_Primary_Surface();

// unload bitmap file
Unload_Bitmap_File(&bitmap8bit);

Sleep(12000);

// transition to black
Screen_Transitions(SCREEN_DARKNESS,NULL,0);

// clear out buffers
DDraw_Fill_Surface(lpddsback, 0);
DDraw_Fill_Surface(lpddsprimary, 0);
}

void Win_Game() {
		// clear out buffers
DDraw_Fill_Surface(lpddsback, 0);
DDraw_Fill_Surface(lpddsprimary, 0);

// draw in logo screen
Load_Bitmap_File(&bitmap8bit, "VICTORY.BMP");

// set the palette to background image palette
Set_Palette(bitmap8bit.palette);

//DDraw_Unlock_Primary_Surface(); // unlock if it is locked so you can move on

// copy the bitmap to primary buffer
DDraw_Lock_Primary_Surface();
Copy_Screen(bitmap8bit.buffer,primary_buffer, primary_lpitch, 0);
DDraw_Unlock_Primary_Surface();

// unload bitmap file
Unload_Bitmap_File(&bitmap8bit);

Sleep(12000);

// transition to black
Screen_Transitions(SCREEN_DARKNESS,NULL,0);

// clear out buffers
DDraw_Fill_Surface(lpddsback, 0);
DDraw_Fill_Surface(lpddsprimary, 0);
}

void Cutscene() {
	// clear out buffers
DDraw_Fill_Surface(lpddsback, 0);
DDraw_Fill_Surface(lpddsprimary, 0);

// draw in logo screen
Load_Bitmap_File(&bitmap8bit, "ALTAR.BMP");

// set the palette to background image palette
Set_Palette(bitmap8bit.palette);

// copy the bitmap to primary buffer
DDraw_Lock_Primary_Surface();
Copy_Screen(bitmap8bit.buffer,primary_buffer, primary_lpitch, 0);
DDraw_Unlock_Primary_Surface();

// unload bitmap file
Unload_Bitmap_File(&bitmap8bit);

Sleep(12000);

// transition to black
Screen_Transitions(SCREEN_DARKNESS,NULL,0);

// clear out buffers
DDraw_Fill_Surface(lpddsback, 0);
DDraw_Fill_Surface(lpddsprimary, 0);
}

///////////////////////////////////////////////////////////

int Game_Main(void *parms, int num_parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!

int          index;             // looping var
int          dx,dy;             // general deltas used in collision detection
 
static int   player_moving = 0; // tracks player motion
static PALETTEENTRY glow = {0,0,0,PC_NOCOLLAPSE};  // used to animation green border

// get player input
// get the keyboard data
lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);

// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);

// lock the back buffer
DDraw_Lock_Back_Surface();

// draw the background reactor image
Draw_Bitmap(&landscape[curr_page], back_buffer, back_lpitch, 0);

// unlock the back buffer
DDraw_Unlock_Back_Surface();

// reset motion flag
player_moving = 0;

// test direction of motion
if (KEY_DOWN(VK_RIGHT)) 
   {
   // move skelaton
   skelaton.x+=2;
   dx=2; dy=0;

   // set motion flag
   player_moving = 1;

   // check animation needs to change
   if (skelaton.curr_animation != SKELATON_EAST)
      Set_Animation_BOB(&skelaton,SKELATON_EAST);

   } // end if
else
if (KEY_DOWN(VK_LEFT))  
   {
   // move skelaton
   skelaton.x-=2;
   dx=-2; dy=0; 
   
   // set motion flag
   player_moving = 1;

   // check animation needs to change
   if (skelaton.curr_animation != SKELATON_WEST)
      Set_Animation_BOB(&skelaton,SKELATON_WEST);

   } // end if

if (keyboard_state[DIK_A] & 0x80)
	{
	//initiate attack
	if (skelaton.curr_animation != SKELATON_SOUTH)
		Set_Animation_BOB(&skelaton,SKELATON_SOUTH);
	//targetdestroyed=true;
}

// apply downward gravity to player,
// so player follows terrain
//skelaton.y+=1;



// only animate if player is moving
if (player_moving)
   {
   // animate skelaton
   Animate_BOB(&skelaton);
   } // end if

//animate if attacking
if (keyboard_state[DIK_A] & 0x80) {
	Animate_BOB(&skelaton);
}

//colission detection
if (curr_page == 0) {
if (Collision_BOBS(&skelaton, &princess)) {
	if (keyboard_state[DIK_A] & 0x80) {
		DSound_Play(swordsound);
		Hide_BOB(&princess);
		Set_Pos_BOB(&princess,0,0);
	}
	else {// didn't attack!
		health-=25;
		Set_Pos_BOB(&skelaton, skelaton.x-30,skelaton.y);
	}
}
else if (Collision_BOBS(&skelaton, &peasant)) {
	if (keyboard_state[DIK_A] & 0x80) {
		DSound_Play(swordsound);
		Hide_BOB(&peasant);
		Set_Pos_BOB(&peasant,0,0);
	}
	else {// didn't attack!
		health-=25;
		Set_Pos_BOB(&skelaton, skelaton.x-30,skelaton.y);
	}
}
else if (Collision_BOBS(&skelaton, &knight)) {
	if (keyboard_state[DIK_A] & 0x80) {
		DSound_Play(swordsound);
		Hide_BOB(&knight);
		Set_Pos_BOB(&knight,0,0);
		targetdestroyed=true;
	}
	else {// didn't attack!
		health-=50;
		Set_Pos_BOB(&skelaton, skelaton.x-30,skelaton.y);
	}
}
}
else if (curr_page == 1) {
if (Collision_BOBS(&skelaton, &wizard)) {
	if (keyboard_state[DIK_A] & 0x80) {
		DSound_Play(swordsound);
		Hide_BOB(&wizard);
		Set_Pos_BOB(&wizard,0,0);
	}
	else {// didn't attack!
		health-=25;
		Set_Pos_BOB(&skelaton, skelaton.x-30,skelaton.y);
	}
}
else if (Collision_BOBS(&skelaton, &monk)) {
	if (keyboard_state[DIK_A] & 0x80) {
		DSound_Play(swordsound);
		Hide_BOB(&monk);
		Set_Pos_BOB(&monk,0,0);
	}
	else {// didn't attack!
		health-=25;
		Set_Pos_BOB(&skelaton, skelaton.x-30,skelaton.y);
	}
}
else if (Collision_BOBS(&skelaton, &warrior)) {
	if (keyboard_state[DIK_A] & 0x80) {
		DSound_Play(swordsound);
		Hide_BOB(&warrior);
		Set_Pos_BOB(&warrior,0,0);
		targetdestroyed=true;
	}
	else {// didn't attack!
		health-=50;
		Set_Pos_BOB(&skelaton, skelaton.x-30,skelaton.y);
	}
}
}
if (curr_page == 2) {
if (Collision_BOBS(&skelaton, &skull)) {
	DSound_Play(swordsound);
	if (keyboard_state[DIK_A] & 0x80) {
		skullhealth -= 10;
		// move skull back
		Set_Pos_BOB(&skull, MAX_X_FLY, MIN_Y_FLY);
		if (skullhealth <= 0) { // win game
			Win_Game();
			Game_Shutdown();
		}
	}
	else {// didn't attack!
		health-=50;
		Set_Pos_BOB(&skelaton, skelaton.x-30,skelaton.y);
	}
}
}
if (health <= 0) {
	GameOver();
	Game_Shutdown();
}


// lock surface, so we can scan it
DDraw_Lock_Back_Surface();
   
// call the color scanner with FLOOR_COLOR, the color of the glowing floor
// try to center the scan on the feet of the player, make sure feet stay
// in contact with floor
//while(Color_Scan(skelaton.x+16, skelaton.y+24,
//               skelaton.x+skelaton.width-32, skelaton.y+skelaton.height-12,                                    
//               FLOOR_COLOR, FLOOR_COLOR, back_buffer,back_lpitch))
//   {
   // push the skelaton upward, to keep it on the floor
   //skelaton.y-=1;
   
//   } // end while

enemy_AI(); // calls Enemy AI

// done, so unlock
DDraw_Unlock_Back_Surface();

// draw the skelaton
Draw_BOB(&skelaton, lpddsback);
if (curr_page == 0) { 
	Draw_BOB(&princess, lpddsback);
	Set_Pos_BOB(&warrior, 0, 0);
	Set_Pos_BOB(&wizard, 0, 0);
	Set_Pos_BOB(&monk, 0, 0);
	Draw_BOB(&knight, lpddsback);
	Draw_BOB(&peasant, lpddsback);
}
if (curr_page == 1) {
	Draw_BOB(&warrior, lpddsback);
	Draw_BOB(&wizard, lpddsback);
	Draw_BOB(&monk, lpddsback);
}
if (curr_page == 2) Draw_BOB(&skull, lpddsback);

// this performs the animation for the glowing rock
static int glow_count = 0;

// increment action counter and test
if (++glow_count > 5)
   {
   // rotate the colors
   //Rotate_Colors(152,159);
   // reset the counter
   glow_count = 0;
   } // end if

// animate the floor
//glow.peGreen = rand()%256;
//Set_Palette_Entry(FLOOR_COLOR, &glow);

// draw some text
Draw_Text_GDI("Controls: <- ->: Move left/right A: Attack <ESC>: Quit",8,8,RGB(255,255,255),lpddsback);

Draw_Text_GDI("Health: ", 8, 154, RGB(255,255,255), lpddsback);
//Draw_Text_GDI((char*)(health), 42, 54, RGB(255,255,255), lpddsback);
if (health == 100) {
	Draw_Text_GDI("100%",60,154,RGB(255,255,255),lpddsback);
}
else if (health == 75) {
	Draw_Text_GDI("75%",60,154,RGB(255,255,255),lpddsback);
}
else if (health == 50) {
	Draw_Text_GDI("50%",60,154,RGB(255,255,255),lpddsback);
}
else { // health=25
	Draw_Text_GDI("25%",60,154,RGB(255,255,255),lpddsback);
}

if (curr_page == 2) { // boss health should be displayed
	Draw_Text_GDI("BOSS: ",260,154,RGB(255,255,255),lpddsback);
	switch (skullhealth) {
	case 100: Draw_Text_GDI("100%",312,154,RGB(255,255,255),lpddsback); break;
	case 90: Draw_Text_GDI("90%",312,154,RGB(255,255,255),lpddsback); break;
	case 80: Draw_Text_GDI("80%",312,154,RGB(255,255,255),lpddsback); break;
	case 70: Draw_Text_GDI("70%",312,154,RGB(255,255,255),lpddsback); break;
	case 60: Draw_Text_GDI("60%",312,154,RGB(255,255,255),lpddsback); break;
	case 50: Draw_Text_GDI("50%",312,154,RGB(255,255,255),lpddsback); break;
	case 40: Draw_Text_GDI("40%",312,154,RGB(255,255,255),lpddsback); break;
	case 30: Draw_Text_GDI("30%",312,154,RGB(255,255,255),lpddsback); break;
	case 20: Draw_Text_GDI("20%",312,154,RGB(255,255,255),lpddsback); break;
	case 10: Draw_Text_GDI("10%",312,154,RGB(255,255,255),lpddsback); break;
	};
}

// test for page flip right
if (skelaton.x > SCREEN_WIDTH - (skelaton.width >> 1))
   {
   // bump back regardless
   skelaton.x-=dx;

   // test for page flip
   if (curr_page < 2)
      { 
      // scroll to next page to right
	   if (targetdestroyed) {
		curr_page++;
		targetdestroyed=false;
		//reset to left
		skelaton.x=-(skelaton.width >> 1);

		// switch level music for next level
		DSound_Stop_Sound(levelmusic); // stop and delete
		DSound_Delete_Sound(levelmusic);
		if (curr_page == 1) { // 2nd level start
			//allocate next level to memory
			levelmusic = DSound_Load_WAV("LEVEL2.WAV");
			//play it
			DSound_Play(levelmusic, DSBPLAY_LOOPING);

			//reset enemy positions and show
			Set_Animation_BOB(&monk, 0);
			Set_Anim_Speed_BOB(&monk,0);
			Set_Vel_BOB(&monk,0,0);
			Set_Pos_BOB(&monk,200,410);

			Set_Animation_BOB(&warrior, 0);
			Set_Anim_Speed_BOB(&warrior,0);
			Set_Vel_BOB(&warrior,0,0);
			Set_Pos_BOB(&warrior,570,410);

			Set_Animation_BOB(&wizard, 0);
			Set_Anim_Speed_BOB(&wizard,0);
			Set_Vel_BOB(&wizard,0,0);
			Set_Pos_BOB(&wizard,400,410);

			Show_BOB(&wizard);
			Show_BOB(&warrior);
			Show_BOB(&monk);
		}
		else { // 3rd level start
			levelmusic = DSound_Load_WAV("LEVEL3.WAV");
			DSound_Play(levelmusic, DSBPLAY_LOOPING);
			Cutscene();
			Set_Palette(bitmap8bit.palette);
			Set_Animation_BOB(&skull, 0);
			Set_Anim_Speed_BOB(&skull,0);
			Set_Vel_BOB(&skull,0,0);
			Set_Pos_BOB(&skull, 320-32+rand()%64, 450-rand()%32);
			skull.curr_frame = 0;
			skullhealth = 100;
			//load boss only!

		}
	   }
	   else {
		   //stay there
		   
	   }

      // reset character to left edge of screen
      //skelaton.x = -(skelaton.width >> 1);
   
      } // end if

   } // end if   
else // page flip right?
if (skelaton.x < -(skelaton.width >> 1))
   {
   // bump back regardless
   skelaton.x=-(skelaton.width >> 1);

   // test for page flip
   //if (curr_page > 0)
     // { 
      // scroll to next page to left
      //curr_page--;

      // reset character to right edge of screen
      //skelaton.x = SCREEN_WIDTH - (skelaton.width >> 1);
   
      //} // end if

   } // end if   

// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(30);

// return success
return(1);

} // end Game_Main

//////////////////////////////////////////////////////////